
/*  A Bison parser, made from ebnf.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define YYLSP_NEEDED

#define	INCLUDE	257
#define	SIMPLE	258
#define	CHANNEL	259
#define	DELAY	260
#define	ERROR	261
#define	DATARATE	262
#define	MODULE	263
#define	PARAMETERS	264
#define	GATES	265
#define	GATESIZES	266
#define	SUBMODULES	267
#define	CONNECTIONS	268
#define	DISPLAY	269
#define	IN	270
#define	OUT	271
#define	NOCHECK	272
#define	LEFT_ARROW	273
#define	RIGHT_ARROW	274
#define	FOR	275
#define	TO	276
#define	DO	277
#define	IF	278
#define	LIKE	279
#define	NETWORK	280
#define	ENDSIMPLE	281
#define	ENDMODULE	282
#define	ENDCHANNEL	283
#define	ENDNETWORK	284
#define	ENDFOR	285
#define	MACHINES	286
#define	ON	287
#define	IO_INTERFACES	288
#define	IFPAIR	289
#define	INTCONSTANT	290
#define	REALCONSTANT	291
#define	NAME	292
#define	STRING	293
#define	_TRUE	294
#define	_FALSE	295
#define	INPUT	296
#define	REF	297
#define	ANCESTOR	298
#define	NED_CONST	299
#define	NUMERICTYPE	300
#define	STRINGTYPE	301
#define	BOOLTYPE	302
#define	ANYTYPE	303
#define	PLUS	304
#define	MIN	305
#define	MUL	306
#define	DIV	307
#define	MOD	308
#define	EXP	309
#define	SIZEOF	310
#define	SUBMODINDEX	311
#define	EQ	312
#define	NE	313
#define	GT	314
#define	GE	315
#define	LS	316
#define	LE	317
#define	AND	318
#define	OR	319
#define	XOR	320
#define	NOT	321
#define	BIN_AND	322
#define	BIN_OR	323
#define	BIN_XOR	324
#define	BIN_COMPL	325
#define	SHIFT_LEFT	326
#define	SHIFT_RIGHT	327
#define	INVALID_CHAR	328
#define	UMIN	329

#line 75 "ebnf.y"


/*
 * Note:
 * This file (ebnf.y) and ebnf.lex are shared between NEDC and GNED.
 * (Exactly the same files are present in both packages;
 * this is to eliminate the burden of keeping 2 sets of files in sync.)
 *
 * Naturally, NEDC and GNED want to do different things while parsing.
 * Both code is present in this file, using the GNED(), NEC(), DOING_GNED,
 * DOING_NEDC macros. These macros come from ebnfcfg.h which is different
 * in gned and nedc.
 *
 * IMPORTANT:
 * If a grammar rule contains code for both nedc and gned, DO _NOT_ PUT THE
 * NEDC() AND GNED() MACROS IN SEPARATE BRACE PAIRS!
 * So this is WRONG:
 *               {NEDC(...)}
 *               {GNED(...)}
 * This is right:
 *               {NEDC(...)
 *                GNED(...)}
 * The reason is that Bison doesn't handle multiple subsequent actions
 * very well; what's worse, it doesn't even warn about them.
 */


/*
 * Note 2:
 * This file contains 2 shift-reduce conflicts around 'timeconstant'.
 * 4 more at opt_semicolon's after module/submodule types.
 * Plus 3 more to track down.
 *
 * bison's "%expect nn" option cannot be used to suppress the
 * warning message because %expect is not recognized by yacc
 */


#include <stdio.h>
#include <malloc.h>         /* for alloca() */
#include "ebnf.h"           /* selects between NEDC and GNED */
#include "ebnfcfg.h"        /* selects between NEDC and GNED */

#define YYDEBUG 1           /* allow debugging */
#define YYDEBUGGING_ON 0    /* turn on/off debugging */

#if YYDEBUG != 0
#define YYERROR_VERBOSE     /* more detailed error messages */
#include <string.h>         /* YYVERBOSE needs it */
#ifdef CXX                  /* For TRU64 c++ compiler */
#include <malloc.h>
#include <stdlib.h>
#include <alloca.h>
#endif                      /* Required to compile ebnf.y derivatives */
#endif


int yylex (void);
void yyrestart(FILE *);
void yyerror (char *s);


//
// stuff needed by NEDC
//
#ifdef DOING_NEDC
#include "jar_func.h"
#include "jar_lib.h"
#endif


//
// stuff needed by GNED
//
#ifdef DOING_GNED

#include "parsened.h"
#include "nedfile.h"

static YYLTYPE NULLPOS={0,0,0,0,0,0};
static int in_loop;
static int in_network;

NEDParser *np;

#define NEDFILE_KEY       np->nedfile_key
#define IMPORTS_KEY       np->imports_key
#define IMPORT_KEY        np->import_key
#define CHANNEL_KEY       np->channel_key
#define CHANATTR_KEY      np->chanattr_key
#define NETWORK_KEY       np->network_key
#define MODULE_KEY        np->module_key  // also plays the role of SIMPLE_KEY
#define PARAMS_KEY        np->params_key
#define PARAM_KEY         np->param_key
#define GATES_KEY         np->gates_key
#define GATE_KEY          np->gate_key
#define MACHINES_KEY      np->machines_key
#define MACHINE_KEY       np->machine_key
#define SUBMODS_KEY       np->submods_key
#define SUBMOD_KEY        np->submod_key
#define SUBSTPARAMS_KEY   np->substparams_key
#define SUBSTPARAM_KEY    np->substparam_key
#define GATESIZES_KEY     np->gatesizes_key
#define GATESIZE_KEY      np->gatesize_key
#define SUBSTMACHINES_KEY np->substmachines_key
#define SUBSTMACHINE_KEY  np->substmachine_key
#define CONNS_KEY         np->conns_key
#define CONN_KEY          np->conn_key
#define CONNATTR_KEY      np->connattr_key
#define FORLOOP_KEY       np->forloop_key
#define LOOPVAR_KEY       np->loopvar_key

void setFileComment(int key);
void setBannerComment(int key, YYLTYPE tokenpos);
void setRightComment(int key, YYLTYPE tokenpos);
void setTrailingComment(int key, YYLTYPE tokenpos);
void setComments(int key, YYLTYPE pos);
void setComments(int key, YYLTYPE firstpos, YYLTYPE lastpos);
int addChanAttr(int channel_key, char *attrname, YYLTYPE valuepos);
int addParameter(int params_key, YYLTYPE namepos, int type);
int addGate(int gates_key, YYLTYPE namepos, int is_in, int is_vector );
int addSubmodule(int submods_key, YYLTYPE namepos, YYLTYPE vectorpos,
                                   YYLTYPE typepos,YYLTYPE likepos);
int addGateSize(int gatesizes_key, YYLTYPE namepos, YYLTYPE vectorpos);
int addSubstparam(int substparams_key, YYLTYPE namepos, YYLTYPE valuepos);
int addSubstmachine(int substmachines_key, YYLTYPE namepos);
int addConnAttr(int conn_key, char *attrname, YYLTYPE valuepos);
int addLoopVar(int forloop_key, YYLTYPE varnamepos, YYLTYPE frompos, YYLTYPE topos);
int addNetwork(int nedfile_key, YYLTYPE namepos, YYLTYPE typepos, YYLTYPE likepos);
int findSubmoduleKey(YYLTYPE modulenamepos);
YYLTYPE trimBrackets(YYLTYPE vectorpos);
YYLTYPE trimQuotes(YYLTYPE vectorpos);
void swapConnection(int conn_key);
void setDisplayString(int key, YYLTYPE dispstrpos);
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		506
#define	YYFLAG		-32768
#define	YYNTBASE	86

#define YYTRANSLATE(x) ((unsigned)(x) <= 329 ? yytranslate[x] : 221)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    84,
    85,     2,     2,    79,     2,    83,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    76,    78,     2,
    82,     2,    75,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    80,     2,    81,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    77
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,     8,    10,    12,    14,    16,    18,
    19,    24,    28,    30,    32,    35,    39,    43,    47,    52,
    57,    62,    67,    72,    77,    83,    89,    95,   101,   107,
   113,   116,   117,   122,   123,   127,   131,   135,   139,   145,
   149,   153,   156,   165,   169,   173,   176,   178,   179,   181,
   182,   184,   185,   187,   188,   190,   191,   193,   194,   195,
   200,   203,   204,   208,   210,   212,   217,   218,   223,   226,
   227,   231,   233,   235,   239,   242,   246,   251,   256,   260,
   264,   268,   269,   274,   276,   277,   282,   286,   291,   295,
   299,   301,   305,   307,   311,   313,   317,   319,   320,   325,
   327,   328,   331,   333,   334,   335,   344,   345,   346,   356,
   357,   358,   369,   370,   371,   383,   384,   389,   391,   392,
   395,   397,   398,   403,   404,   411,   414,   415,   419,   421,
   423,   425,   426,   429,   431,   432,   437,   438,   445,   448,
   449,   453,   455,   459,   462,   463,   464,   469,   470,   477,
   480,   481,   485,   487,   490,   492,   497,   498,   499,   505,
   506,   511,   514,   515,   519,   521,   523,   525,   526,   533,
   537,   539,   545,   548,   549,   552,   553,   557,   560,   566,
   574,   580,   588,   592,   594,   597,   599,   602,   604,   607,
   609,   613,   615,   618,   620,   623,   625,   628,   630,   631,
   633,   635,   637,   639,   642,   645,   648,   651,   654,   657,
   661,   665,   669,   673,   677,   681,   683,   686,   689,   692,
   693,   694,   695,   707,   708,   709,   710,   724,   727,   731,
   733,   735,   742,   747,   751,   753,   755,   757,   761,   765,
   769,   773,   777,   781,   785,   788,   792,   796,   800,   804,
   808,   812,   816,   820,   824,   827,   831,   835,   839,   842,
   846,   850,   856,   860,   865,   872,   881,   892,   894,   896,
   898,   900,   902,   904,   907,   910,   914,   918,   922,   927,
   932,   938,   940,   942,   944,   946,   948,   953,   955,   957,
   959,   963,   967,   970,   973,   975,   976,   978,   980
};

static const short yyrhs[] = {    87,
     0,     0,    87,    88,     0,    88,     0,    89,     0,    93,
     0,   101,     0,   104,     0,   198,     0,     0,     3,    90,
    91,    78,     0,    91,    79,    92,     0,    92,     0,    39,
     0,    94,    95,     0,    94,    99,    95,     0,    94,    98,
    95,     0,    94,   100,    95,     0,    94,    99,    98,    95,
     0,    94,    99,   100,    95,     0,    94,    98,   100,    95,
     0,    94,    98,    99,    95,     0,    94,   100,    99,    95,
     0,    94,   100,    98,    95,     0,    94,    99,    98,   100,
    95,     0,    94,    99,   100,    98,    95,     0,    94,    98,
    99,   100,    95,     0,    94,    98,   100,    99,    95,     0,
    94,   100,    99,    98,    95,     0,    94,   100,    98,    99,
    95,     0,     5,    38,     0,     0,    29,    38,   219,    96,
     0,     0,    29,   219,    97,     0,     7,   209,   219,     0,
     6,   209,   219,     0,     8,   209,   219,     0,   102,   107,
   109,   110,   103,     0,     4,    38,   219,     0,    27,    38,
   219,     0,    27,   219,     0,   105,   107,   109,   110,   111,
   112,   108,   106,     0,     9,    38,   219,     0,    28,    38,
   219,     0,    28,   219,     0,   113,     0,     0,   118,     0,
     0,   119,     0,     0,   124,     0,     0,   132,     0,     0,
   171,     0,     0,     0,    32,    76,   114,   115,     0,   116,
    78,     0,     0,   116,    79,   117,     0,   117,     0,    38,
     0,    15,    76,    39,    78,     0,     0,    10,    76,   120,
   121,     0,   122,    78,     0,     0,   122,    79,   123,     0,
   123,     0,    38,     0,    38,    76,    46,     0,    45,    38,
     0,    38,    76,    45,     0,    38,    76,    45,    46,     0,
    38,    76,    46,    45,     0,    38,    76,    47,     0,    38,
    76,    48,     0,    38,    76,    49,     0,     0,    11,    76,
   125,   126,     0,   127,     0,     0,   127,    16,   128,    78,
     0,    16,   128,    78,     0,   127,    17,   130,    78,     0,
    17,   130,    78,     0,   128,    79,   129,     0,   129,     0,
    38,    80,    81,     0,    38,     0,   130,    79,   131,     0,
   131,     0,    38,    80,    81,     0,    38,     0,     0,    13,
    76,   133,   134,     0,   135,     0,     0,   135,   136,     0,
   136,     0,     0,     0,    38,    76,    38,   219,   137,   147,
   138,   145,     0,     0,     0,    38,    76,    38,   206,   219,
   139,   147,   140,   145,     0,     0,     0,    38,    76,    38,
    25,    38,   219,   141,   147,   142,   145,     0,     0,     0,
    38,    76,    38,   206,    25,    38,   219,   143,   147,   144,
   145,     0,     0,   155,   146,   163,   170,     0,   148,     0,
     0,   148,   149,     0,   149,     0,     0,    33,    76,   150,
   152,     0,     0,    33,    24,   209,    76,   151,   152,     0,
   153,    78,     0,     0,   153,    79,   154,     0,   154,     0,
    38,     0,   156,     0,     0,   156,   157,     0,   157,     0,
     0,    10,    76,   158,   160,     0,     0,    10,    24,   209,
    76,   159,   160,     0,   161,    78,     0,     0,   161,    79,
   162,     0,   162,     0,    38,    82,   207,     0,   164,   163,
     0,     0,     0,    12,    76,   165,   167,     0,     0,    12,
    24,   209,    76,   166,   167,     0,   168,    78,     0,     0,
   168,    79,   169,     0,   169,     0,    38,   206,     0,    38,
     0,    15,    76,    39,    78,     0,     0,     0,    14,    18,
    76,   172,   174,     0,     0,    14,    76,   173,   174,     0,
   175,    78,     0,     0,   175,   220,   176,     0,   176,     0,
   177,     0,   184,     0,     0,    21,   178,   179,    23,   183,
    31,     0,   179,    79,   180,     0,   180,     0,    38,    82,
   209,    22,   209,     0,    24,   209,     0,     0,    15,    39,
     0,     0,   183,   184,   220,     0,   184,   220,     0,   185,
    20,   189,   181,   182,     0,   185,    20,   193,    20,   189,
   181,   182,     0,   185,    19,   189,   181,   182,     0,   185,
    19,   193,    19,   189,   181,   182,     0,   186,    83,   187,
     0,   188,     0,    38,   206,     0,    38,     0,    38,   206,
     0,    38,     0,    38,   206,     0,    38,     0,   190,    83,
   191,     0,   192,     0,    38,   206,     0,    38,     0,    38,
   206,     0,    38,     0,    38,   206,     0,    38,     0,     0,
   194,     0,   195,     0,   196,     0,   197,     0,   195,   196,
     0,   195,   197,     0,   196,   197,     0,   196,   195,     0,
   197,   195,     0,   197,   196,     0,   195,   196,   197,     0,
   195,   197,   196,     0,   196,   195,   197,     0,   196,   197,
   195,     0,   197,   195,   196,     0,   197,   196,   195,     0,
    38,     0,     6,   209,     0,     7,   209,     0,     8,   209,
     0,     0,     0,     0,    26,    38,    76,    38,   219,   199,
   147,   200,   155,   201,   205,     0,     0,     0,     0,    26,
    38,    76,    38,    25,    38,   219,   202,   147,   203,   155,
   204,   205,     0,    30,   219,     0,    80,   209,    81,     0,
   208,     0,   209,     0,    42,    84,   209,    79,   209,    85,
     0,    42,    84,   209,    85,     0,    42,    84,    85,     0,
    42,     0,   210,     0,   211,     0,    84,   210,    85,     0,
   210,    50,   210,     0,   210,    51,   210,     0,   210,    52,
   210,     0,   210,    53,   210,     0,   210,    54,   210,     0,
   210,    55,   210,     0,    51,   210,     0,   210,    58,   210,
     0,   210,    59,   210,     0,   210,    60,   210,     0,   210,
    61,   210,     0,   210,    62,   210,     0,   210,    63,   210,
     0,   210,    64,   210,     0,   210,    65,   210,     0,   210,
    66,   210,     0,    67,   210,     0,   210,    68,   210,     0,
   210,    69,   210,     0,   210,    70,   210,     0,    71,   210,
     0,   210,    72,   210,     0,   210,    73,   210,     0,   210,
    75,   210,    76,   210,     0,    38,    84,    85,     0,    38,
    84,   210,    85,     0,    38,    84,   210,    79,   210,    85,
     0,    38,    84,   210,    79,   210,    79,   210,    85,     0,
    38,    84,   210,    79,   210,    79,   210,    79,   210,    85,
     0,   212,     0,   213,     0,   214,     0,   215,     0,   216,
     0,    38,     0,    43,    38,     0,    44,    38,     0,    43,
    44,    38,     0,    44,    43,    38,     0,    38,    83,    38,
     0,    43,    38,    83,    38,     0,    38,   206,    83,    38,
     0,    43,    38,   206,    83,    38,     0,    39,     0,    40,
     0,    41,     0,   217,     0,    57,     0,    56,    84,    38,
    85,     0,    36,     0,    37,     0,   218,     0,    36,    38,
   218,     0,    37,    38,   218,     0,    36,    38,     0,    37,
    38,     0,    78,     0,     0,    79,     0,    78,     0,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   216,   217,   221,   222,   226,   227,   228,   229,   230,   234,
   237,   243,   244,   248,   257,   260,   262,   264,   267,   269,
   271,   273,   275,   277,   280,   282,   284,   286,   288,   290,
   295,   304,   306,   307,   309,   314,   321,   328,   335,   343,
   352,   355,   361,   372,   380,   383,   389,   390,   393,   393,
   394,   394,   395,   395,   396,   396,   397,   397,   400,   404,
   407,   408,   412,   413,   417,   425,   431,   436,   439,   440,
   444,   447,   452,   455,   458,   461,   464,   467,   470,   473,
   476,   482,   487,   490,   491,   495,   496,   497,   498,   502,
   503,   507,   511,   518,   519,   523,   527,   534,   539,   542,
   543,   547,   548,   552,   557,   559,   559,   564,   566,   566,
   571,   573,   573,   578,   580,   583,   586,   591,   592,   597,
   598,   602,   607,   607,   613,   617,   618,   623,   624,   628,
   635,   636,   640,   641,   645,   650,   650,   656,   660,   661,
   665,   666,   670,   677,   678,   682,   687,   687,   693,   697,
   698,   702,   703,   707,   711,   718,   721,   725,   731,   731,
   737,   740,   741,   745,   746,   750,   751,   755,   759,   765,
   766,   770,   777,   780,   785,   788,   793,   794,   798,   801,
   804,   808,   815,   816,   820,   825,   832,   836,   842,   848,
   856,   857,   861,   865,   871,   875,   881,   886,   894,   896,
   898,   900,   902,   905,   907,   909,   911,   913,   915,   918,
   920,   922,   924,   926,   928,   933,   939,   945,   951,   957,
   962,   964,   966,   967,   970,   974,   976,   980,   985,   990,
   991,   995,   997,   999,  1001,  1006,  1012,  1014,  1017,  1019,
  1021,  1023,  1025,  1027,  1030,  1034,  1036,  1038,  1040,  1042,
  1044,  1047,  1049,  1051,  1053,  1057,  1059,  1061,  1063,  1066,
  1068,  1070,  1072,  1074,  1076,  1078,  1080,  1085,  1086,  1087,
  1088,  1089,  1093,  1095,  1097,  1099,  1101,  1104,  1106,  1109,
  1111,  1116,  1121,  1123,  1128,  1133,  1135,  1140,  1141,  1142,
  1146,  1148,  1150,  1152,  1157,  1157,  1158,  1158,  1158
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INCLUDE",
"SIMPLE","CHANNEL","DELAY","ERROR","DATARATE","MODULE","PARAMETERS","GATES",
"GATESIZES","SUBMODULES","CONNECTIONS","DISPLAY","IN","OUT","NOCHECK","LEFT_ARROW",
"RIGHT_ARROW","FOR","TO","DO","IF","LIKE","NETWORK","ENDSIMPLE","ENDMODULE",
"ENDCHANNEL","ENDNETWORK","ENDFOR","MACHINES","ON","IO_INTERFACES","IFPAIR",
"INTCONSTANT","REALCONSTANT","NAME","STRING","_TRUE","_FALSE","INPUT","REF",
"ANCESTOR","NED_CONST","NUMERICTYPE","STRINGTYPE","BOOLTYPE","ANYTYPE","PLUS",
"MIN","MUL","DIV","MOD","EXP","SIZEOF","SUBMODINDEX","EQ","NE","GT","GE","LS",
"LE","AND","OR","XOR","NOT","BIN_AND","BIN_OR","BIN_XOR","BIN_COMPL","SHIFT_LEFT",
"SHIFT_RIGHT","INVALID_CHAR","'?'","':'","UMIN","';'","','","'['","']'","'='",
"'.'","'('","')'","networkdescription","somedefinitions","definition","import",
"@1","filenames","filename","channeldefinition","channelheader","endchannel",
"@2","@3","cherror","chdelay","chdatarate","simpledefinition","simpleheader",
"endsimple","moduledefinition","moduleheader","endmodule","opt_machineblock",
"opt_displayblock","opt_paramblock","opt_gateblock","opt_submodblock","opt_connblock",
"machineblock","@4","opt_machinelist","machinelist","machine","displayblock",
"paramblock","@5","opt_parameters","parameters","parameter","gateblock","@6",
"opt_gates","gates","gatesI","gateI","gatesO","gateO","submodblock","@7","opt_submodules",
"submodules","submodule","@8","@9","@10","@11","@12","@13","@14","@15","submodule_body",
"@16","opt_on_blocks","on_blocks","on_block","@17","@18","opt_on_list","on_list",
"on_mach","opt_substparamblocks","substparamblocks","substparamblock","@19",
"@20","opt_substparameters","substparameters","substparameter","opt_gatesizeblocks",
"gatesizeblock","@21","@22","opt_gatesizes","gatesizes","gatesize","opt_submod_displayblock",
"connblock","@23","@24","opt_connections","connections","connection","loopconnection",
"@25","loopvarlist","loopvar","opt_conn_condition","opt_conn_displaystr","notloopconnections",
"notloopconnection","gate_spec_L","mod_L","gate_L","parentgate_L","gate_spec_R",
"mod_R","gate_R","parentgate_R","channeldescr","cdname","cddelay","cderror",
"cddatarate","network","@26","@27","@28","@29","@30","@31","endnetwork","vector",
"inputvalue_or_expression","inputvalue","expression","expr","simple_expr","parameter_expr",
"string_expr","boolconst_expr","numconst_expr","special_expr","numconst","timeconstant",
"opt_semicolon","comma_or_semicolon", NULL
};
#endif

static const short yyr1[] = {     0,
    86,    86,    87,    87,    88,    88,    88,    88,    88,    90,
    89,    91,    91,    92,    93,    93,    93,    93,    93,    93,
    93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
    94,    96,    95,    97,    95,    98,    99,   100,   101,   102,
   103,   103,   104,   105,   106,   106,   107,   107,   108,   108,
   109,   109,   110,   110,   111,   111,   112,   112,   114,   113,
   115,   115,   116,   116,   117,   118,   120,   119,   121,   121,
   122,   122,   123,   123,   123,   123,   123,   123,   123,   123,
   123,   125,   124,   126,   126,   127,   127,   127,   127,   128,
   128,   129,   129,   130,   130,   131,   131,   133,   132,   134,
   134,   135,   135,   137,   138,   136,   139,   140,   136,   141,
   142,   136,   143,   144,   136,   146,   145,   147,   147,   148,
   148,   150,   149,   151,   149,   152,   152,   153,   153,   154,
   155,   155,   156,   156,   158,   157,   159,   157,   160,   160,
   161,   161,   162,   163,   163,   165,   164,   166,   164,   167,
   167,   168,   168,   169,   169,   170,   170,   172,   171,   173,
   171,   174,   174,   175,   175,   176,   176,   178,   177,   179,
   179,   180,   181,   181,   182,   182,   183,   183,   184,   184,
   184,   184,   185,   185,   186,   186,   187,   187,   188,   188,
   189,   189,   190,   190,   191,   191,   192,   192,   193,   193,
   193,   193,   193,   193,   193,   193,   193,   193,   193,   193,
   193,   193,   193,   193,   193,   194,   195,   196,   197,   199,
   200,   201,   198,   202,   203,   204,   198,   205,   206,   207,
   207,   208,   208,   208,   208,   209,   210,   210,   210,   210,
   210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
   210,   210,   210,   210,   210,   210,   210,   210,   210,   210,
   210,   210,   210,   210,   210,   210,   210,   211,   211,   211,
   211,   211,   212,   212,   212,   212,   212,   212,   212,   212,
   212,   213,   214,   214,   215,   216,   216,   217,   217,   217,
   218,   218,   218,   218,   219,   219,   220,   220,   220
};

static const short yyr2[] = {     0,
     1,     0,     2,     1,     1,     1,     1,     1,     1,     0,
     4,     3,     1,     1,     2,     3,     3,     3,     4,     4,
     4,     4,     4,     4,     5,     5,     5,     5,     5,     5,
     2,     0,     4,     0,     3,     3,     3,     3,     5,     3,
     3,     2,     8,     3,     3,     2,     1,     0,     1,     0,
     1,     0,     1,     0,     1,     0,     1,     0,     0,     4,
     2,     0,     3,     1,     1,     4,     0,     4,     2,     0,
     3,     1,     1,     3,     2,     3,     4,     4,     3,     3,
     3,     0,     4,     1,     0,     4,     3,     4,     3,     3,
     1,     3,     1,     3,     1,     3,     1,     0,     4,     1,
     0,     2,     1,     0,     0,     8,     0,     0,     9,     0,
     0,    10,     0,     0,    11,     0,     4,     1,     0,     2,
     1,     0,     4,     0,     6,     2,     0,     3,     1,     1,
     1,     0,     2,     1,     0,     4,     0,     6,     2,     0,
     3,     1,     3,     2,     0,     0,     4,     0,     6,     2,
     0,     3,     1,     2,     1,     4,     0,     0,     5,     0,
     4,     2,     0,     3,     1,     1,     1,     0,     6,     3,
     1,     5,     2,     0,     2,     0,     3,     2,     5,     7,
     5,     7,     3,     1,     2,     1,     2,     1,     2,     1,
     3,     1,     2,     1,     2,     1,     2,     1,     0,     1,
     1,     1,     1,     2,     2,     2,     2,     2,     2,     3,
     3,     3,     3,     3,     3,     1,     2,     2,     2,     0,
     0,     0,    11,     0,     0,     0,    13,     2,     3,     1,
     1,     6,     4,     3,     1,     1,     1,     3,     3,     3,
     3,     3,     3,     3,     2,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     2,     3,     3,     3,     2,     3,
     3,     5,     3,     4,     6,     8,    10,     1,     1,     1,
     1,     1,     1,     2,     2,     3,     3,     3,     4,     4,
     5,     1,     1,     1,     1,     1,     4,     1,     1,     1,
     3,     3,     2,     2,     1,     0,     1,     1,     0
};

static const short yydefact[] = {     2,
    10,     0,     0,     0,     0,     1,     4,     5,     6,     0,
     7,    48,     8,    48,     9,     0,   296,    31,   296,     0,
     3,     0,     0,     0,   296,    15,     0,     0,     0,     0,
    52,    47,    52,    14,     0,    13,   295,    40,    44,     0,
   288,   289,   273,   282,   283,   284,     0,     0,     0,     0,
   286,     0,     0,     0,   296,   236,   237,   268,   269,   270,
   271,   272,   285,   290,   296,   296,   296,    34,    17,     0,
     0,    16,     0,     0,    18,     0,     0,    59,     0,    54,
    51,    54,    11,     0,   296,   293,   294,     0,     0,     0,
     0,   274,     0,   275,     0,   245,     0,   255,   259,     0,
    37,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    36,    38,    32,    35,    22,     0,    21,     0,
    19,     0,    20,     0,    24,     0,    23,     0,    62,    67,
     0,     0,    53,    56,    12,     0,   220,     0,     0,   291,
   292,     0,   278,   263,     0,     0,     0,     0,   276,   277,
     0,   238,   239,   240,   241,   242,   243,   244,   246,   247,
   248,   249,   250,   251,   252,   253,   254,   256,   257,   258,
   260,   261,     0,    33,    27,    28,    25,    26,    30,    29,
    65,    60,     0,    64,    70,    82,   296,    39,     0,    58,
    55,   296,   119,   229,     0,   264,   280,   279,     0,   287,
     0,    61,     0,    73,     0,    68,     0,    72,    85,   296,
    42,    98,     0,    50,    57,   224,     0,   221,   118,   121,
     0,   281,   262,    63,     0,    75,    69,     0,     0,     0,
    83,    84,    41,   101,     0,   160,     0,     0,    49,   119,
     0,   122,   132,   120,     0,   265,    76,    74,    79,    80,
    81,    71,    93,     0,    91,    97,     0,    95,     0,     0,
     0,    99,   100,   103,   158,   163,     0,   296,    43,   225,
     0,   127,     0,   222,   131,   134,     0,    77,    78,     0,
    87,     0,     0,    89,     0,     0,     0,     0,   102,   163,
   168,   190,   161,   299,   165,   166,   167,     0,     0,   184,
     0,   296,    46,   132,   124,   130,   123,     0,   129,     0,
   135,     0,   133,     0,   266,    92,    90,    96,    94,    86,
    88,   296,   159,     0,   189,   162,   297,     0,   199,   199,
     0,    66,    45,   226,   127,   126,     0,     0,   140,   296,
   223,     0,     0,   296,   104,     0,     0,   171,   164,     0,
     0,     0,   198,   174,     0,   192,     0,   200,   201,   202,
   203,   174,     0,   188,   183,     0,   125,   128,   137,     0,
   136,     0,   142,   228,   267,   296,     0,   107,   119,     0,
     0,     0,   217,   218,   219,   197,     0,   176,     0,     0,
   204,   205,   207,   206,   208,   209,   176,     0,   187,   227,
   140,     0,   139,     0,   110,   296,   119,   105,     0,     0,
   299,   170,   173,     0,   181,   196,   191,   198,   174,   210,
   211,   212,   213,   214,   215,   179,   174,   138,   235,   143,
   230,   231,   141,   119,   113,   108,   132,     0,   169,   299,
   298,   178,   175,   195,   176,   176,     0,   111,   119,   132,
   106,   116,   172,   177,   182,   180,   234,     0,   132,   114,
   109,   145,     0,   233,   112,   132,     0,   157,   145,     0,
   115,     0,   146,     0,   117,   144,   232,     0,   151,     0,
   148,   155,   147,     0,   153,     0,   151,   154,   150,     0,
   156,   149,   152,     0,     0,     0
};

static const short yydefgoto[] = {   504,
     6,     7,     8,    16,    35,    36,     9,    10,    26,   184,
   126,    27,    28,    29,    11,    12,   198,    13,    14,   279,
    31,   248,    80,   142,   200,   224,    32,   139,   192,   193,
   194,   249,    81,   195,   216,   217,   218,   143,   219,   241,
   242,   264,   265,   267,   268,   201,   244,   272,   273,   274,
   389,   447,   417,   460,   444,   469,   459,   476,   461,   472,
   228,   229,   230,   282,   345,   317,   318,   319,   462,   285,
   286,   349,   411,   381,   382,   383,   478,   479,   489,   497,
   493,   494,   495,   485,   225,   300,   276,   303,   304,   305,
   306,   334,   357,   358,   398,   425,   420,   307,   308,   309,
   375,   310,   364,   365,   427,   366,   367,   368,   369,   370,
   371,    15,   203,   253,   322,   250,   314,   376,   351,   396,
   440,   441,    55,    56,    57,    58,    59,    60,    61,    62,
    63,    64,    38,   338
};

static const short yypact[] = {   238,
-32768,    -2,    83,    87,    98,   238,-32768,-32768,-32768,   120,
-32768,   111,-32768,   111,-32768,   159,   129,-32768,   129,    96,
-32768,   233,   233,   233,   -25,-32768,   112,    14,   220,   135,
   199,-32768,   199,-32768,   127,-32768,-32768,-32768,-32768,   176,
   179,   192,    51,-32768,-32768,-32768,    -6,    -4,   233,   156,
-32768,   233,   233,   233,   129,   521,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,   129,   129,   129,-32768,-32768,    17,
   131,-32768,    17,    11,-32768,   131,    11,-32768,   172,   239,
-32768,   239,-32768,   159,    -5,   208,   208,   233,   225,    73,
   182,    67,   229,-32768,   237,-32768,   258,-32768,-32768,   438,
-32768,   233,   233,   233,   233,   233,   233,   233,   233,   233,
   233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
   233,   233,-32768,-32768,-32768,-32768,-32768,   249,-32768,   249,
-32768,   249,-32768,   249,-32768,   249,-32768,   249,   265,-32768,
   223,   299,-32768,   288,-32768,   298,-32768,   179,   192,-32768,
-32768,   262,-32768,-32768,   296,   307,   325,   287,-32768,-32768,
   295,-32768,   148,   148,   327,   327,   327,   327,   255,   255,
   255,   255,   255,   255,   571,   571,   571,   342,   342,   342,
   261,   261,   494,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   141,-32768,    -8,-32768,    60,-32768,   303,   369,
-32768,   129,   351,-32768,   233,-32768,-32768,-32768,   348,-32768,
   233,-32768,   265,   311,   350,-32768,   175,-32768,   264,   129,
-32768,-32768,   -13,   375,-32768,-32768,   -14,-32768,   351,-32768,
   358,-32768,   547,-32768,   211,-32768,-32768,    -8,   353,   360,
-32768,   266,-32768,   361,   326,-32768,   329,   372,-32768,   351,
   233,-32768,   391,-32768,   233,-32768,   357,   359,-32768,-32768,
-32768,-32768,   349,   207,-32768,   352,   209,-32768,   353,   360,
   331,-32768,   361,-32768,-32768,   118,   396,    77,-32768,-32768,
   362,   398,    30,-32768,   391,-32768,   402,-32768,-32768,   363,
-32768,   353,   364,-32768,   360,   214,   216,   401,-32768,   118,
-32768,   103,-32768,   240,-32768,-32768,-32768,   301,   365,-32768,
   368,   129,-32768,   391,-32768,-32768,-32768,   251,-32768,   233,
-32768,   410,-32768,   233,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,    19,-32768,   403,   366,   124,-32768,   118,   217,   217,
   404,-32768,-32768,-32768,   398,-32768,   398,   371,   420,   129,
-32768,   466,   431,    22,-32768,   394,    -9,-32768,-32768,   233,
   233,   233,   -12,   449,   395,-32768,   460,-32768,   324,   183,
   328,   449,   462,   400,-32768,   410,-32768,-32768,-32768,   412,
-32768,   263,-32768,-32768,-32768,   129,   445,-32768,   351,   233,
   446,   403,-32768,-32768,-32768,   422,   233,   470,   448,   457,
   501,   505,   501,   508,   505,   508,   470,   457,-32768,-32768,
   420,   195,-32768,   420,-32768,   129,   351,-32768,   493,    -7,
   274,-32768,-32768,   483,-32768,   400,-32768,   133,   449,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   449,-32768,   453,-32768,
-32768,-32768,-32768,   351,-32768,-32768,   391,   233,-32768,   274,
-32768,-32768,-32768,-32768,   470,   470,   137,-32768,   351,   391,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -50,   391,-32768,
-32768,   528,   233,-32768,-32768,   391,    43,   518,   528,   458,
-32768,   233,-32768,   474,-32768,-32768,-32768,   485,   504,   526,
-32768,   400,-32768,   294,-32768,   490,   504,-32768,-32768,   504,
-32768,-32768,-32768,   577,   578,-32768
};

static const short yypgoto[] = {-32768,
-32768,   582,-32768,-32768,-32768,   511,-32768,-32768,    31,-32768,
-32768,    94,   119,   126,-32768,-32768,-32768,-32768,-32768,-32768,
   589,-32768,   559,   522,-32768,-32768,-32768,-32768,-32768,-32768,
   405,-32768,-32768,-32768,-32768,-32768,   376,-32768,-32768,-32768,
-32768,   367,   335,   377,   333,-32768,-32768,-32768,-32768,   373,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -427,-32768,
  -247,-32768,   406,-32768,-32768,   292,-32768,   302,  -242,-32768,
   370,-32768,-32768,   227,-32768,   228,   166,-32768,-32768,-32768,
   151,-32768,   150,-32768,-32768,-32768,-32768,   354,-32768,   313,
-32768,-32768,-32768,   260,  -368,  -304,-32768,  -379,-32768,-32768,
-32768,-32768,  -334,-32768,-32768,-32768,   316,-32768,  -354,  -187,
  -237,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   277,   -41,
-32768,-32768,   -23,   -26,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,   291,   -10,  -402
};


#define	YYLAST		656


static const short yytable[] = {    65,
    66,    91,   280,   407,   245,   372,  -216,  -216,    39,   251,
   284,   421,    67,   391,    68,   403,   405,    23,   452,   146,
    23,    24,    96,   449,    24,    98,    99,   100,   473,   214,
   302,    92,   471,    94,   474,    17,   215,    93,    95,    25,
   450,   475,    25,   353,   101,    25,   387,   464,   481,   433,
   158,   435,    37,   320,   123,   124,   125,    69,    72,    75,
   455,   252,   246,   155,   152,   429,   482,    88,   456,   392,
  -194,   344,    37,   437,   147,   163,   164,   165,   166,   167,
   168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
   178,   179,   180,   181,   182,   183,    37,   220,    88,    37,
   127,   129,   436,   131,   133,   321,   135,   137,    41,    42,
    43,    44,    45,    46,   312,    47,    48,    22,   483,    24,
    18,    73,    76,    49,    19,    22,    23,    24,    50,    51,
    88,   402,   404,    89,    90,    20,    22,    37,   301,    52,
    25,   418,    30,    53,  -298,    70,    88,    77,    25,   157,
   465,   466,    71,    74,    37,   302,    54,   154,   185,    25,
   186,  -298,   187,   430,   188,   432,   189,   134,   190,   446,
   138,    40,    41,    42,    43,    44,    45,    46,   231,    47,
    48,   401,    88,   406,   233,  -186,   221,    49,   360,   130,
   362,   226,    50,    51,   136,   128,   458,    34,   132,   104,
   105,   106,   107,    52,    83,    84,    37,    53,    79,   243,
    78,   470,    88,    85,   431,  -194,    86,   434,   212,   213,
    54,   467,   360,   361,   362,    22,    23,   281,   287,    87,
    41,    42,    43,    44,    45,    46,   439,    47,    48,    97,
     1,     2,     3,   148,   149,    49,     4,   140,    25,   141,
    50,    51,   237,   238,   363,   257,   258,   259,   260,   261,
   335,    52,   153,     5,   156,    53,   159,   313,    41,    42,
    43,    44,    45,    46,   160,    47,    48,    25,    54,   239,
   240,   269,   270,    49,   291,   292,   294,   295,    50,    51,
   354,   330,   292,   331,   295,   161,   348,   352,   196,    52,
   199,   343,   191,    53,   102,   103,   104,   105,   106,   107,
   102,   103,   104,   105,   106,   107,    54,   336,   337,   339,
   340,   355,   117,   118,   119,   197,   120,   121,   346,   347,
   361,   362,   409,   360,   361,   202,   393,   394,   395,   384,
   413,   414,   204,   388,   207,   102,   103,   104,   105,   106,
   107,   451,   337,   108,   109,   110,   111,   112,   113,   114,
   115,   116,   208,   117,   118,   119,   419,   120,   121,   209,
   122,   499,   500,   423,   205,   415,   150,   151,   222,   210,
   206,   107,   223,   227,   454,   232,   235,   236,   442,   247,
   263,   102,   103,   104,   105,   106,   107,   266,   271,   278,
   283,   275,   288,   289,   277,   445,   298,   102,   103,   104,
   105,   106,   107,   120,   121,   108,   109,   110,   111,   112,
   113,   114,   115,   116,   463,   117,   118,   119,   290,   120,
   121,   293,   122,   468,   311,   316,   255,   315,   332,   350,
   356,   374,   256,   326,   328,   342,   379,   341,  -185,   480,
   498,   102,   103,   104,   105,   106,   107,   380,   488,   108,
   109,   110,   111,   112,   113,   114,   115,   116,   386,   117,
   118,   119,   397,   120,   121,   390,   122,   399,   400,    88,
   324,   408,   416,   302,   424,   426,   325,   102,   103,   104,
   105,   106,   107,   412,   428,   108,   109,   110,   111,   112,
   113,   114,   115,   116,  -193,   117,   118,   119,   362,   120,
   121,   361,   122,   360,   448,   102,   103,   104,   105,   106,
   107,   453,   162,   108,   109,   110,   111,   112,   113,   114,
   115,   116,   484,   117,   118,   119,   457,   120,   121,   477,
   122,   492,   487,   102,   103,   104,   105,   106,   107,   490,
   385,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   491,   117,   118,   119,   496,   120,   121,   501,   122,   211,
   102,   103,   104,   105,   106,   107,   505,   506,   108,   109,
   110,   111,   112,   113,   114,   115,   116,    21,   117,   118,
   119,    82,   120,   121,   145,   122,   102,   103,   104,   105,
   106,   107,    33,   144,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   262,   117,   118,   119,   234,   120,   121,
   102,   103,   104,   105,   106,   107,   327,   329,   108,   109,
   110,   111,   112,   113,   254,   296,   377,   438,   117,   118,
   119,   443,   120,   121,   486,   299,   297,   502,   378,   503,
   359,   422,   410,   333,   323,   373
};

static const short yycheck[] = {    23,
    24,    43,   250,   372,    18,   340,    19,    20,    19,    24,
   253,   391,    38,    23,    25,   370,   371,     7,   421,    25,
     7,     8,    49,    31,     8,    52,    53,    54,    79,    38,
    38,    38,   460,    38,    85,    38,    45,    44,    43,    29,
   420,   469,    29,    25,    55,    29,    25,   450,   476,   404,
    92,   406,    78,    24,    65,    66,    67,    27,    28,    29,
   429,    76,    76,    90,    88,   400,    24,    80,   437,    79,
    83,   314,    78,   408,    85,   102,   103,   104,   105,   106,
   107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
   117,   118,   119,   120,   121,   122,    78,    38,    80,    78,
    70,    71,   407,    73,    74,    76,    76,    77,    36,    37,
    38,    39,    40,    41,    38,    43,    44,     6,    76,     8,
    38,    28,    29,    51,    38,     6,     7,     8,    56,    57,
    80,   369,   370,    83,    84,    38,     6,    78,    21,    67,
    29,   389,    32,    71,    21,    27,    80,    29,    29,    83,
   455,   456,    27,    28,    78,    38,    84,    85,   128,    29,
   130,    38,   132,   401,   134,   403,   136,    74,   138,   417,
    77,    76,    36,    37,    38,    39,    40,    41,   205,    43,
    44,   369,    80,   371,   211,    83,   197,    51,     6,    71,
     8,   202,    56,    57,    76,    70,   444,    39,    73,    52,
    53,    54,    55,    67,    78,    79,    78,    71,    10,   220,
    76,   459,    80,    38,   402,    83,    38,   405,    78,    79,
    84,    85,     6,     7,     8,     6,     7,   251,   255,    38,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    84,
     3,     4,     5,    36,    37,    51,     9,    76,    29,    11,
    56,    57,    78,    79,    38,    45,    46,    47,    48,    49,
   302,    67,    38,    26,    83,    71,    38,   278,    36,    37,
    38,    39,    40,    41,    38,    43,    44,    29,    84,    16,
    17,    16,    17,    51,    78,    79,    78,    79,    56,    57,
   332,    78,    79,    78,    79,    38,   320,   324,    76,    67,
    13,   312,    38,    71,    50,    51,    52,    53,    54,    55,
    50,    51,    52,    53,    54,    55,    84,    78,    79,    19,
    20,   332,    68,    69,    70,    27,    72,    73,    78,    79,
     7,     8,   374,     6,     7,    38,   360,   361,   362,   350,
    78,    79,    81,   354,    38,    50,    51,    52,    53,    54,
    55,    78,    79,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    38,    68,    69,    70,   390,    72,    73,    83,
    75,    78,    79,   397,    79,   386,    86,    87,    76,    85,
    85,    55,    14,    33,   426,    38,    76,    38,   412,    15,
    38,    50,    51,    52,    53,    54,    55,    38,    38,    28,
    10,    76,    46,    45,    76,   416,    76,    50,    51,    52,
    53,    54,    55,    72,    73,    58,    59,    60,    61,    62,
    63,    64,    65,    66,   448,    68,    69,    70,    80,    72,
    73,    80,    75,   457,    39,    38,    79,    76,    38,    30,
    38,    38,    85,    81,    81,    78,    76,    83,    83,   473,
   492,    50,    51,    52,    53,    54,    55,    38,   482,    58,
    59,    60,    61,    62,    63,    64,    65,    66,    38,    68,
    69,    70,    24,    72,    73,    82,    75,    83,    19,    80,
    79,    20,    38,    38,    15,    38,    85,    50,    51,    52,
    53,    54,    55,    82,    38,    58,    59,    60,    61,    62,
    63,    64,    65,    66,    83,    68,    69,    70,     8,    72,
    73,     7,    75,     6,    22,    50,    51,    52,    53,    54,
    55,    39,    85,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    15,    68,    69,    70,    84,    72,    73,    12,
    75,    38,    85,    50,    51,    52,    53,    54,    55,    76,
    85,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    76,    68,    69,    70,    39,    72,    73,    78,    75,    76,
    50,    51,    52,    53,    54,    55,     0,     0,    58,    59,
    60,    61,    62,    63,    64,    65,    66,     6,    68,    69,
    70,    33,    72,    73,    84,    75,    50,    51,    52,    53,
    54,    55,    14,    82,    58,    59,    60,    61,    62,    63,
    64,    65,    66,   238,    68,    69,    70,   213,    72,    73,
    50,    51,    52,    53,    54,    55,   292,   295,    58,    59,
    60,    61,    62,    63,   229,   269,   345,   411,    68,    69,
    70,   414,    72,    73,   479,   273,   270,   497,   347,   500,
   338,   392,   376,   300,   285,   340
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 10:
#line 235 "ebnf.y"
{GNED( IMPORTS_KEY = np->create("imports",NEDFILE_KEY);
                       setComments(IMPORTS_KEY,yylsp[0]); );
    break;}
case 11:
#line 238 "ebnf.y"
{/* GNED( setTrailingComment(IMPORTS_KEY,@3); )
                  * comment already stored with last filename */;
    break;}
case 14:
#line 249 "ebnf.y"
{NEDC( do_include (yyvsp[0]); )
                 GNED( IMPORT_KEY = np->create("import",IMPORTS_KEY);
                       np->set(IMPORT_KEY,"name",trimQuotes(yylsp[0]));
                       setComments(IMPORT_KEY,yylsp[0]); );
    break;}
case 15:
#line 258 "ebnf.y"
{NEDC( do_channel (yyvsp[-1], NULL, NULL, NULL); );
    break;}
case 16:
#line 261 "ebnf.y"
{NEDC( do_channel (yyvsp[-2], yyvsp[-1], NULL, NULL); );
    break;}
case 17:
#line 263 "ebnf.y"
{NEDC( do_channel (yyvsp[-2], NULL, yyvsp[-1], NULL); );
    break;}
case 18:
#line 265 "ebnf.y"
{NEDC( do_channel (yyvsp[-2], NULL, NULL, yyvsp[-1]); );
    break;}
case 19:
#line 268 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL); );
    break;}
case 20:
#line 270 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-2], NULL, yyvsp[-1]); );
    break;}
case 21:
#line 272 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], NULL, yyvsp[-2], yyvsp[-1]); );
    break;}
case 22:
#line 274 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-1], yyvsp[-2], NULL); );
    break;}
case 23:
#line 276 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], yyvsp[-1], NULL, yyvsp[-2]); );
    break;}
case 24:
#line 278 "ebnf.y"
{NEDC( do_channel (yyvsp[-3], NULL, yyvsp[-1], yyvsp[-2]); );
    break;}
case 25:
#line 281 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1]); );
    break;}
case 26:
#line 283 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[-2]); );
    break;}
case 27:
#line 285 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-2], yyvsp[-3], yyvsp[-1]); );
    break;}
case 28:
#line 287 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-1], yyvsp[-3], yyvsp[-2]); );
    break;}
case 29:
#line 289 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[-3]); );
    break;}
case 30:
#line 291 "ebnf.y"
{NEDC( do_channel (yyvsp[-4], yyvsp[-1], yyvsp[-2], yyvsp[-3]); );
    break;}
case 31:
#line 296 "ebnf.y"
{NEDC( yyval = yyvsp[0]; inside_nonvoid_function=1;)
                 GNED( CHANNEL_KEY = np->create("channel",NEDFILE_KEY);
                       np->set(CHANNEL_KEY,"name",yylsp[0]);
                       setComments(CHANNEL_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 32:
#line 305 "ebnf.y"
{NEDC( inside_nonvoid_function=0; );
    break;}
case 33:
#line 306 "ebnf.y"
{GNED( setTrailingComment(CHANNEL_KEY,yylsp[-2]); );
    break;}
case 34:
#line 308 "ebnf.y"
{NEDC( inside_nonvoid_function=0; );
    break;}
case 35:
#line 309 "ebnf.y"
{GNED( setTrailingComment(CHANNEL_KEY,yylsp[-2]); );
    break;}
case 36:
#line 315 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; )
                 GNED( CHANATTR_KEY = addChanAttr(CHANNEL_KEY,"error",yylsp[-1]);
                       setComments(CHANATTR_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 37:
#line 322 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; )
                 GNED( CHANATTR_KEY = addChanAttr(CHANNEL_KEY,"delay",yylsp[-1]);
                       setComments(CHANATTR_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 38:
#line 329 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; )
                 GNED( CHANATTR_KEY = addChanAttr(CHANNEL_KEY,"datarate",yylsp[-1]);
                       setComments(CHANATTR_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 40:
#line 344 "ebnf.y"
{NEDC( do_simple (yyvsp[-1]); )
                 GNED( MODULE_KEY = np->create("simple",NEDFILE_KEY);
                       np->set(MODULE_KEY,"name", yylsp[-1]);
                       setComments(MODULE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 41:
#line 353 "ebnf.y"
{NEDC( end_simple (yyvsp[-1]); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 42:
#line 356 "ebnf.y"
{NEDC( end_simple (NULL); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 44:
#line 373 "ebnf.y"
{NEDC( do_module (yyvsp[-1]); )
                 GNED( MODULE_KEY = np->create("module",NEDFILE_KEY);
                       np->set(MODULE_KEY,"name", yylsp[-1]);
                       setComments(MODULE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 45:
#line 381 "ebnf.y"
{NEDC( end_module (yyvsp[-1]); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 46:
#line 384 "ebnf.y"
{NEDC( end_module (NULL); )
                 GNED( setTrailingComment(MODULE_KEY,yylsp[-1]); );
    break;}
case 48:
#line 391 "ebnf.y"
{NEDC( do_machine(jar_strdup("default")); );
    break;}
case 59:
#line 401 "ebnf.y"
{GNED( MACHINES_KEY = np->create("machines",MODULE_KEY);
                       setComments(MACHINES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 65:
#line 418 "ebnf.y"
{NEDC( do_machine (yyvsp[0]); )
                 GNED( MACHINE_KEY = np->create("machine",MACHINES_KEY);
                       np->set(MACHINE_KEY,"name", yylsp[0]);
                       setComments(MACHINE_KEY,yylsp[0],yylsp[0]); );
    break;}
case 66:
#line 426 "ebnf.y"
{NEDC( do_displaystr_enclosing (yyvsp[-1]); )
                 GNED( setDisplayString(MODULE_KEY,yylsp[-1]); );
    break;}
case 67:
#line 432 "ebnf.y"
{NEDC( do_parameters (); )
                 GNED( PARAMS_KEY = np->create("params",MODULE_KEY);
                       setComments(PARAMS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 71:
#line 445 "ebnf.y"
{GNED( setComments(PARAM_KEY,yylsp[0]); );
    break;}
case 72:
#line 448 "ebnf.y"
{GNED( setComments(PARAM_KEY,yylsp[0]); );
    break;}
case 73:
#line 453 "ebnf.y"
{NEDC( do_parameter (yyvsp[0], TYPE_NUMERIC); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[0],TYPE_NUMERIC); );
    break;}
case 74:
#line 456 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_NUMERIC); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_NUMERIC); );
    break;}
case 75:
#line 459 "ebnf.y"
{NEDC( do_parameter (yyvsp[0], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[0],TYPE_CONST_NUM); );
    break;}
case 76:
#line 462 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_CONST_NUM); );
    break;}
case 77:
#line 465 "ebnf.y"
{NEDC( do_parameter (yyvsp[-3], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-3],TYPE_CONST_NUM); );
    break;}
case 78:
#line 468 "ebnf.y"
{NEDC( do_parameter (yyvsp[-3], TYPE_CONST_NUM); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-3],TYPE_CONST_NUM); );
    break;}
case 79:
#line 471 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_STRING); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_STRING); );
    break;}
case 80:
#line 474 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_BOOL); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_BOOL); );
    break;}
case 81:
#line 477 "ebnf.y"
{NEDC( do_parameter (yyvsp[-2], TYPE_ANYTYPE); )
                 GNED( PARAM_KEY=addParameter(PARAMS_KEY,yylsp[-2],TYPE_ANYTYPE); );
    break;}
case 82:
#line 483 "ebnf.y"
{NEDC( do_gates (); )
                 GNED( GATES_KEY = np->create("gates",MODULE_KEY);
                       setComments(GATES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 92:
#line 508 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[-2], 1, 1 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[-2], 1, 1 );
                       setComments(GATE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 93:
#line 512 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[0], 1, 0 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[0], 1, 0 );
                       setComments(GATE_KEY,yylsp[0]); );
    break;}
case 96:
#line 524 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[-2], 0, 1 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[-2], 0, 1 );
                       setComments(GATE_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 97:
#line 528 "ebnf.y"
{NEDC( do_gatedecl( yyvsp[0], 0, 0 ); )
                 GNED( GATE_KEY=addGate(GATES_KEY,  yylsp[0], 0, 0 );
                       setComments(GATE_KEY,yylsp[0]); );
    break;}
case 98:
#line 535 "ebnf.y"
{NEDC( do_submodules (); )
                 GNED( SUBMODS_KEY = np->create("submods",MODULE_KEY);
                       setComments(SUBMODS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 104:
#line 553 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-3], NULL, yyvsp[-1], NULL); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-3], NULLPOS, yylsp[-1], NULLPOS);
                       setComments(SUBMOD_KEY,yylsp[-3],yylsp[0]);  );
    break;}
case 105:
#line 557 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-5], NULL, yyvsp[-3], NULL); );
    break;}
case 107:
#line 560 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-4], yyvsp[-1], yyvsp[-2], NULL); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-4], yylsp[-1], yylsp[-2], NULLPOS);
                       setComments(SUBMOD_KEY,yylsp[-4],yylsp[0]);  );
    break;}
case 108:
#line 564 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-6], yyvsp[-3], yyvsp[-4], NULL); );
    break;}
case 110:
#line 567 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-5], NULL, yyvsp[-3], yyvsp[-1]); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-5], NULLPOS, yylsp[-3], yylsp[-1]);
                       setComments(SUBMOD_KEY,yylsp[-5],yylsp[0]);  );
    break;}
case 111:
#line 571 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-7], NULL, yyvsp[-5], yyvsp[-3]); );
    break;}
case 113:
#line 574 "ebnf.y"
{NEDC( do_submodule1 (yyvsp[-6], yyvsp[-3], yyvsp[-4], yyvsp[-1]); )
                 GNED( SUBMOD_KEY=addSubmodule(SUBMODS_KEY, yylsp[-6], yylsp[-3], yylsp[-4], yylsp[-1]);
                       setComments(SUBMOD_KEY,yylsp[-6],yylsp[0]);  );
    break;}
case 114:
#line 578 "ebnf.y"
{NEDC( do_submodule2 (yyvsp[-8], yyvsp[-5], yyvsp[-6], yyvsp[-3]); );
    break;}
case 116:
#line 584 "ebnf.y"
{NEDC( do_readallparameters(); );
    break;}
case 117:
#line 587 "ebnf.y"
{NEDC( end_submodule (); );
    break;}
case 119:
#line 593 "ebnf.y"
{NEDC( do_empty_onlist(); );
    break;}
case 122:
#line 603 "ebnf.y"
{NEDC( do_onlist(); )
                 GNED( SUBSTMACHINES_KEY = np->create("substmachines",in_network?NETWORK_KEY:SUBMOD_KEY);
                       setComments(SUBSTMACHINES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 124:
#line 608 "ebnf.y"
{NEDC( open_if(yyvsp[-1]); do_onlist(); )
                 GNED( SUBSTMACHINES_KEY = np->create("substmachines",in_network?NETWORK_KEY:SUBMOD_KEY);
                       np->set(SUBSTMACHINES_KEY,"condition",yylsp[-1]);
                       setComments(SUBSTMACHINES_KEY,yylsp[-3],yylsp[0]); );
    break;}
case 125:
#line 613 "ebnf.y"
{NEDC( close_if(); );
    break;}
case 127:
#line 619 "ebnf.y"
{NEDC( do_empty_onlist(); );
    break;}
case 130:
#line 629 "ebnf.y"
{NEDC( do_on_mach(yyvsp[0]); )
                 GNED( SUBSTMACHINE_KEY = addSubstmachine(SUBSTMACHINES_KEY,yylsp[0]);
                       setComments(SUBSTMACHINE_KEY,yylsp[0]); );
    break;}
case 135:
#line 646 "ebnf.y"
{NEDC( do_substparams (); )
                 GNED( SUBSTPARAMS_KEY = np->create("substparams",in_network?NETWORK_KEY:SUBMOD_KEY);
                       setComments(SUBSTPARAMS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 137:
#line 651 "ebnf.y"
{NEDC( open_if(yyvsp[-1]); do_substparams(); )
                 GNED( SUBSTPARAMS_KEY = np->create("substparams",in_network?NETWORK_KEY:SUBMOD_KEY);
                       np->set(SUBSTPARAMS_KEY,"condition",yylsp[-1]);
                       setComments(SUBSTPARAMS_KEY,yylsp[-3],yylsp[0]); );
    break;}
case 138:
#line 656 "ebnf.y"
{NEDC( close_if(); );
    break;}
case 143:
#line 671 "ebnf.y"
{NEDC( do_substparameter (yyvsp[-2], yyvsp[0]);)
                 GNED( SUBSTPARAM_KEY = addSubstparam(SUBSTPARAMS_KEY,yylsp[-2],yylsp[0]);
                       setComments(SUBSTPARAM_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 146:
#line 683 "ebnf.y"
{NEDC( do_gatesizes (); )
                 GNED( GATESIZES_KEY = np->create("gatesizes",SUBMOD_KEY);
                       setComments(GATESIZES_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 148:
#line 688 "ebnf.y"
{NEDC( open_if(yyvsp[-1]); do_gatesizes (); )
                 GNED( GATESIZES_KEY = np->create("gatesizes",SUBMOD_KEY);
                       np->set(GATESIZES_KEY,"condition",yylsp[-1]);
                       setComments(GATESIZES_KEY,yylsp[-3],yylsp[0]); );
    break;}
case 149:
#line 693 "ebnf.y"
{NEDC( close_if(); );
    break;}
case 154:
#line 708 "ebnf.y"
{NEDC( do_gatesize (yyvsp[-1], yyvsp[0]); )
                 GNED( GATESIZE_KEY = addGateSize(GATESIZES_KEY,yylsp[-1],yylsp[0]);
                       setComments(GATESIZE_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 155:
#line 712 "ebnf.y"
{NEDC( do_gatesize (yyvsp[0], NULL); )
                 GNED( GATESIZE_KEY = addGateSize(GATESIZES_KEY,yylsp[0],NULLPOS);
                       setComments(GATESIZE_KEY,yylsp[0]); );
    break;}
case 156:
#line 719 "ebnf.y"
{NEDC( do_displaystr_submod (yyvsp[-1]); )
                 GNED( setDisplayString(SUBMOD_KEY,yylsp[-1]); );
    break;}
case 158:
#line 726 "ebnf.y"
{NEDC( set_checkconns(0); do_connections(); )
                 GNED( CONNS_KEY = np->create("conns",MODULE_KEY);
                       np->set(CONNS_KEY,"nocheck","1");
                       setComments(CONNS_KEY,yylsp[-2],yylsp[0]); );
    break;}
case 160:
#line 732 "ebnf.y"
{NEDC( set_checkconns(1); do_connections(); )
                 GNED( CONNS_KEY = np->create("conns",MODULE_KEY);
                       np->set(CONNS_KEY,"nocheck","0");
                       setComments(CONNS_KEY,yylsp[-1],yylsp[0]); );
    break;}
case 168:
#line 756 "ebnf.y"
{NEDC( do_for (); )
                 GNED( FORLOOP_KEY = np->create("forloop",CONNS_KEY);
                       in_loop=1; setComments(FORLOOP_KEY,yylsp[0]); );
    break;}
case 169:
#line 760 "ebnf.y"
{NEDC( end_for (); )
                 GNED( in_loop=0; setTrailingComment(FORLOOP_KEY,yylsp[0]); );
    break;}
case 172:
#line 771 "ebnf.y"
{NEDC( do_index (yyvsp[-4], yyvsp[-2], yyvsp[0]); )
                 GNED( LOOPVAR_KEY=addLoopVar(FORLOOP_KEY,yylsp[-4],yylsp[-2],yylsp[0]);
                       setComments(LOOPVAR_KEY,yylsp[-4],yylsp[0]); );
    break;}
case 173:
#line 778 "ebnf.y"
{NEDC( do_condition(yyvsp[0]); )
                 GNED( np->set(CONN_KEY,"condition",yylsp[0]); );
    break;}
case 174:
#line 781 "ebnf.y"
{NEDC( do_condition(NULL); );
    break;}
case 175:
#line 786 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( setDisplayString(CONN_KEY,yylsp[0]); );
    break;}
case 176:
#line 789 "ebnf.y"
{NEDC( yyval = NULL; );
    break;}
case 179:
#line 799 "ebnf.y"
{NEDC( end_connection (NULL, 'R', yyvsp[0]); )
                 GNED( np->set(CONN_KEY,"arrowdir-l2r",1L); setComments(CONN_KEY,yylsp[-4],yylsp[0]); );
    break;}
case 180:
#line 802 "ebnf.y"
{NEDC( end_connection (yyvsp[-4], 'R', yyvsp[0]); )
                 GNED( np->set(CONN_KEY,"arrowdir-l2r",1L); setComments(CONN_KEY,yylsp[-6],yylsp[0]); );
    break;}
case 181:
#line 805 "ebnf.y"
{NEDC( end_connection (NULL, 'L', yyvsp[0]); )
                 GNED( swapConnection(CONN_KEY);
                       np->set(CONN_KEY,"arrowdir-l2r",0L); setComments(CONN_KEY,yylsp[-4],yylsp[0]); );
    break;}
case 182:
#line 809 "ebnf.y"
{NEDC( end_connection (yyvsp[-4], 'L', yyvsp[0]); )
                 GNED( swapConnection(CONN_KEY);
                 np->set(CONN_KEY,"arrowdir-l2r",0L); setComments(CONN_KEY,yylsp[-6],yylsp[0]); );
    break;}
case 185:
#line 821 "ebnf.y"
{NEDC( do_mod_L (yyvsp[-1], yyvsp[0]); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", findSubmoduleKey(yylsp[-1]));
                       np->set(CONN_KEY, "src-mod-index", trimBrackets(yylsp[0])); );
    break;}
case 186:
#line 826 "ebnf.y"
{NEDC( do_mod_L (yyvsp[0], NULL); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", findSubmoduleKey(yylsp[0])); );
    break;}
case 187:
#line 833 "ebnf.y"
{NEDC( do_gate_L (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "srcgate", yylsp[-1]);
                       np->set(CONN_KEY, "src-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 188:
#line 837 "ebnf.y"
{NEDC( do_gate_L (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "srcgate", yylsp[0]); );
    break;}
case 189:
#line 843 "ebnf.y"
{NEDC( do_mod_L (NULL, NULL); do_gate_L (yyvsp[-1], yyvsp[0]); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "srcgate", yylsp[-1]);
                       np->set(CONN_KEY, "src-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 190:
#line 849 "ebnf.y"
{NEDC( do_mod_L (NULL, NULL); do_gate_L (yyvsp[0], NULL); )
                 GNED( CONN_KEY = np->create("conn",in_loop?FORLOOP_KEY:CONNS_KEY);
                       np->set(CONN_KEY, "src-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "srcgate", yylsp[0]); );
    break;}
case 193:
#line 862 "ebnf.y"
{NEDC( do_mod_R (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", findSubmoduleKey(yylsp[-1]));
                       np->set(CONN_KEY, "dest-mod-index", trimBrackets(yylsp[0])); );
    break;}
case 194:
#line 866 "ebnf.y"
{NEDC( do_mod_R (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", findSubmoduleKey(yylsp[0])); );
    break;}
case 195:
#line 872 "ebnf.y"
{NEDC( do_gate_R (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "destgate", yylsp[-1]);
                       np->set(CONN_KEY, "dest-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 196:
#line 876 "ebnf.y"
{NEDC( do_gate_R (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "destgate", yylsp[0]); );
    break;}
case 197:
#line 882 "ebnf.y"
{NEDC( do_mod_R (NULL, NULL); do_gate_R (yyvsp[-1], yyvsp[0]); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "destgate", yylsp[-1]);
                       np->set(CONN_KEY, "dest-gate-index", trimBrackets(yylsp[0])); );
    break;}
case 198:
#line 887 "ebnf.y"
{NEDC( do_mod_R (NULL, NULL); do_gate_R (yyvsp[0], NULL); )
                 GNED( np->set(CONN_KEY, "dest-ownerkey", MODULE_KEY);
                       np->set(CONN_KEY, "destgate", yylsp[0]); );
    break;}
case 199:
#line 895 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, NULL, NULL); );
    break;}
case 200:
#line 897 "ebnf.y"
{NEDC( yyval = do_channeldescr(yyvsp[0], NULL,NULL,NULL); );
    break;}
case 201:
#line 899 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], NULL, NULL); );
    break;}
case 202:
#line 901 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, yyvsp[0], NULL); );
    break;}
case 203:
#line 903 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, NULL, yyvsp[0]); );
    break;}
case 204:
#line 906 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], yyvsp[0], NULL); );
    break;}
case 205:
#line 908 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], NULL, yyvsp[0]); );
    break;}
case 206:
#line 910 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, yyvsp[-1], yyvsp[0]); );
    break;}
case 207:
#line 912 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], yyvsp[-1], NULL); );
    break;}
case 208:
#line 914 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], NULL, yyvsp[-1]); );
    break;}
case 209:
#line 916 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, NULL, yyvsp[0], yyvsp[-1]); );
    break;}
case 210:
#line 919 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-2], yyvsp[-1], yyvsp[0]); );
    break;}
case 211:
#line 921 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-2], yyvsp[0], yyvsp[-1]); );
    break;}
case 212:
#line 923 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], yyvsp[-2], yyvsp[0]); );
    break;}
case 213:
#line 925 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], yyvsp[-2], yyvsp[-1]); );
    break;}
case 214:
#line 927 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[-1], yyvsp[0], yyvsp[-2]); );
    break;}
case 215:
#line 929 "ebnf.y"
{NEDC( yyval = do_channeldescr( NULL, yyvsp[0], yyvsp[-1], yyvsp[-2]); );
    break;}
case 216:
#line 934 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"channel",yylsp[0]); );
    break;}
case 217:
#line 940 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"delay",yylsp[0]); );
    break;}
case 218:
#line 946 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"error",yylsp[0]); );
    break;}
case 219:
#line 952 "ebnf.y"
{NEDC( yyval = yyvsp[0]; )
                 GNED( CONNATTR_KEY=addConnAttr(CONN_KEY,"datarate",yylsp[0]); );
    break;}
case 220:
#line 958 "ebnf.y"
{NEDC( do_system (yyvsp[-3]); )
                 GNED( NETWORK_KEY = addNetwork(NEDFILE_KEY,yylsp[-3],yylsp[-1],NULLPOS);
                       setComments(NETWORK_KEY,yylsp[-4],yylsp[0]); in_network=1;);
    break;}
case 221:
#line 962 "ebnf.y"
{NEDC( do_systemmodule (yyvsp[-5], yyvsp[-3], NULL); );
    break;}
case 222:
#line 964 "ebnf.y"
{NEDC( do_readallparameters(); );
    break;}
case 223:
#line 966 "ebnf.y"
{NEDC( end_system (); );
    break;}
case 224:
#line 968 "ebnf.y"
{NEDC( do_system (yyvsp[-5]); );
    break;}
case 225:
#line 970 "ebnf.y"
{NEDC( do_systemmodule (yyvsp[-7], yyvsp[-5], yyvsp[-3]); )
                 GNED( NETWORK_KEY = addNetwork(NEDFILE_KEY,yylsp[-7],yylsp[-5],yylsp[-3]);
                       setComments(NETWORK_KEY,yylsp[-8],yylsp[-2]); );
    break;}
case 226:
#line 974 "ebnf.y"
{NEDC( do_readallparameters(); );
    break;}
case 227:
#line 976 "ebnf.y"
{NEDC( end_system (); );
    break;}
case 228:
#line 981 "ebnf.y"
{GNED( setTrailingComment(NETWORK_KEY,yylsp[-1]); in_network=0; );
    break;}
case 229:
#line 986 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; );
    break;}
case 232:
#line 996 "ebnf.y"
{NEDC( yyval = do_inputvalue(yyvsp[-3], yyvsp[-1]); );
    break;}
case 233:
#line 998 "ebnf.y"
{NEDC( yyval = do_inputvalue(yyvsp[-1], NULL); );
    break;}
case 234:
#line 1000 "ebnf.y"
{NEDC( yyval = do_inputvalue(NULL, NULL); );
    break;}
case 235:
#line 1002 "ebnf.y"
{NEDC( yyval = do_inputvalue(NULL, NULL); );
    break;}
case 236:
#line 1008 "ebnf.y"
{NEDC( yyval = end_expr( yyvsp[0] ); );
    break;}
case 237:
#line 1013 "ebnf.y"
{NEDC( yyval = yyvsp[0]; );
    break;}
case 238:
#line 1015 "ebnf.y"
{NEDC( yyval = yyvsp[-1]; );
    break;}
case 239:
#line 1018 "ebnf.y"
{NEDC( yyval = do_op( 2, '+', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 240:
#line 1020 "ebnf.y"
{NEDC( yyval = do_op( 2, '-', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 241:
#line 1022 "ebnf.y"
{NEDC( yyval = do_op( 2, '*', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 242:
#line 1024 "ebnf.y"
{NEDC( yyval = do_op( 2, '/', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 243:
#line 1026 "ebnf.y"
{NEDC( yyval = do_op( 2, '%', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 244:
#line 1028 "ebnf.y"
{NEDC( yyval = do_op( 2, '^', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 245:
#line 1032 "ebnf.y"
{NEDC( yyval = do_addminus(yyvsp[0]); );
    break;}
case 246:
#line 1035 "ebnf.y"
{NEDC( yyval = do_op( 2, '=', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 247:
#line 1037 "ebnf.y"
{NEDC( yyval = do_op( 2, '!', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 248:
#line 1039 "ebnf.y"
{NEDC( yyval = do_op( 2, '>', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 249:
#line 1041 "ebnf.y"
{NEDC( yyval = do_op( 2, '}', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 250:
#line 1043 "ebnf.y"
{NEDC( yyval = do_op( 2, '<', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 251:
#line 1045 "ebnf.y"
{NEDC( yyval = do_op( 2, '{', yyvsp[-2],yyvsp[0],NULL); );
    break;}
case 252:
#line 1048 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bool_and"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 253:
#line 1050 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bool_or"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 254:
#line 1052 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bool_xor"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 255:
#line 1055 "ebnf.y"
{NEDC( yyval = do_func(1,jar_strdup("bool_not"), yyvsp[0],NULL,NULL,NULL); );
    break;}
case 256:
#line 1058 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bin_and"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 257:
#line 1060 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bin_or"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 258:
#line 1062 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("bin_xor"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 259:
#line 1065 "ebnf.y"
{NEDC( yyval = do_func(1,jar_strdup("bin_compl"), yyvsp[0],NULL,NULL,NULL); );
    break;}
case 260:
#line 1067 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("shift_left"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 261:
#line 1069 "ebnf.y"
{NEDC( yyval = do_func(2,jar_strdup("shift_right"), yyvsp[-2],yyvsp[0],NULL,NULL); );
    break;}
case 262:
#line 1071 "ebnf.y"
{NEDC( yyval = do_op( 3, '?', yyvsp[-4],yyvsp[-2],yyvsp[0]); );
    break;}
case 263:
#line 1073 "ebnf.y"
{NEDC( yyval = do_func(0,yyvsp[-2], NULL,NULL,NULL,NULL); );
    break;}
case 264:
#line 1075 "ebnf.y"
{NEDC( yyval = do_func(1,yyvsp[-3], yyvsp[-1],NULL,NULL,NULL); );
    break;}
case 265:
#line 1077 "ebnf.y"
{NEDC( yyval = do_func(2,yyvsp[-5], yyvsp[-3],yyvsp[-1],NULL,NULL); );
    break;}
case 266:
#line 1079 "ebnf.y"
{NEDC( yyval = do_func(3,yyvsp[-7], yyvsp[-5],yyvsp[-3],yyvsp[-1],NULL); );
    break;}
case 267:
#line 1081 "ebnf.y"
{NEDC( yyval = do_func(3,yyvsp[-9], yyvsp[-7],yyvsp[-5],yyvsp[-3],yyvsp[-1]); );
    break;}
case 273:
#line 1094 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],0,1); );
    break;}
case 274:
#line 1096 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],0,0); );
    break;}
case 275:
#line 1098 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],1,1); );
    break;}
case 276:
#line 1100 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],1,0); );
    break;}
case 277:
#line 1102 "ebnf.y"
{NEDC( yyval = do_parname (0,0,yyvsp[0],1,0); );
    break;}
case 278:
#line 1105 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-2],0,yyvsp[0],0,1); );
    break;}
case 279:
#line 1107 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-2],0,yyvsp[0],0,0); );
    break;}
case 280:
#line 1110 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-3],yyvsp[-2],yyvsp[0],0,1); );
    break;}
case 281:
#line 1112 "ebnf.y"
{NEDC( yyval = do_parname (yyvsp[-3],yyvsp[-2],yyvsp[0],0,0); );
    break;}
case 282:
#line 1117 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_STRING,yyvsp[0]); );
    break;}
case 283:
#line 1122 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_BOOL,jar_strdup("true")); );
    break;}
case 284:
#line 1124 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_BOOL,jar_strdup("false")); );
    break;}
case 285:
#line 1129 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_NUMERIC,yyvsp[0]); );
    break;}
case 286:
#line 1134 "ebnf.y"
{NEDC( yyval = make_literal_expr(TYPE_NUMERIC,jar_strdup("(long)sub_i")); );
    break;}
case 287:
#line 1136 "ebnf.y"
{NEDC( yyval = do_sizeof (yyvsp[-1]); );
    break;}
case 291:
#line 1147 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-2],yyvsp[-1],yyvsp[0]); );
    break;}
case 292:
#line 1149 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-2],yyvsp[-1],yyvsp[0]); );
    break;}
case 293:
#line 1151 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-1],yyvsp[0],NULL); );
    break;}
case 294:
#line 1153 "ebnf.y"
{NEDC( yyval = do_timeconstant(yyvsp[-1],yyvsp[0],NULL); );
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 1160 "ebnf.y"


//----------------------------------------------------------------------
// general bison/flex stuff:
//

char yyfailure[250] = "";
extern int yydebug; /* needed if compiled with yacc --VA */

extern char textbuf[];

int runparse ()
{
#if YYDEBUG != 0      /* #if added --VA */
        yydebug = YYDEBUGGING_ON;
#endif
        pos.co = 0;
        pos.li = 1;
        prevpos = pos;

        strcpy (yyfailure, "");

        if (yyin)
            yyrestart( yyin );

        return yyparse();
}

#ifdef DOING_NEDC

extern char current_fname[];

void yyerror (char *s)
{
        fflush (stdout);
        if (strlen (s))
                strcpy (yyfailure, s);
        if (yyfailure [strlen (yyfailure) - 1] != '\n')
                strcat (yyfailure, "\n");
        if (yyfailure [0] == '!')
                fprintf(stderr,
                        "Warning %s %d: %s",
                        current_fname, pos.li, yyfailure + 1);
        else
                fprintf(stderr,
                        "Error %s %d: %s> %s\n  %*s\n",
                        current_fname, pos.li, yyfailure, textbuf, pos.co, "^");
}

#endif


#ifdef DOING_GNED

void yyerror (char *s)
{
        if (strlen (s))
                strcpy (yyfailure, s);
        if (yyfailure [strlen(yyfailure)-1] == '\n')
                yyfailure [strlen(yyfailure)-1] = '\0';

        if (yyfailure [0] == '!')
                np->error('W', yyfailure, pos.li, pos.co);
        else
                np->error('E', yyfailure, pos.li, pos.co);
}

#endif


//----------------------------------------------------------------------
//
// stuff needed by GNED
//

#ifdef DOING_GNED

void setFileComment(int key)
{
    np->set(key,"comment", np->nedsource->getFileComment());
}

void setBannerComment(int key, YYLTYPE tokenpos)
{
    np->set(key,"banner-comment", np->nedsource->getBannerComment(tokenpos));
}

void setRightComment(int key, YYLTYPE tokenpos)
{
    np->set(key,"right-comment", np->nedsource->getTrailingComment(tokenpos));
}

void setTrailingComment(int key, YYLTYPE tokenpos)
{
    np->set(key,"trailing-comment", np->nedsource->getTrailingComment(tokenpos));
}

void setComments(int key, YYLTYPE pos)
{
    setBannerComment(key, pos);
    setRightComment(key, pos);
}

void setComments(int key, YYLTYPE firstpos, YYLTYPE lastpos)
{
    YYLTYPE pos = firstpos;
    pos.last_line = lastpos.last_line;
    pos.last_column = lastpos.last_column;

    setBannerComment(key, pos);
    setRightComment(key, pos);
}

int addChanAttr(int channel_key, char *attrname, YYLTYPE valuepos)
{
    int chanattr_key = np->create("chanattr", channel_key);
    np->set(chanattr_key,"name", attrname);
    np->set(chanattr_key,"value", valuepos);
    return chanattr_key;
}

int addParameter(int params_key, YYLTYPE namepos, int type)
{
   char *s;
   switch (type)
   {
       case TYPE_NUMERIC:   s = "numeric"; break;
       case TYPE_CONST_NUM: s = "numeric const"; break;
       case TYPE_STRING:    s = "string"; break;
       case TYPE_BOOL:      s = "bool"; break;
       case TYPE_ANYTYPE:   s = "anytype"; break;
       default: s="?";
   }

   int param_key = np->create("param", params_key);
   np->set(param_key, "name", namepos);
   np->set(param_key, "datatype", s);
   return param_key;
}

int addGate(int gates_key, YYLTYPE namepos, int is_in, int is_vector )
{
   int gate_key = np->create("gate", gates_key);
   np->set(gate_key, "name", namepos);
   np->set(gate_key, "gatetype", const_cast<char*> (is_in ? "in" : "out"));
   np->set(gate_key, "isvector", const_cast<char*> (is_vector ? "1" : "0"));
   return gate_key;
}

int addSubmodule(int submods_key, YYLTYPE namepos, YYLTYPE vectorpos,
                                  YYLTYPE typepos,YYLTYPE likepos)
{
   // cut off "[" and "]"
   vectorpos.first_column++;
   vectorpos.last_column--;

   int submod_key = np->create("submod", submods_key);
   np->set(submod_key, "name", namepos);
   np->set(submod_key, "type-name", typepos);
   np->set(submod_key, "vectorsize", vectorpos);
   np->set(submod_key, "like-name", likepos);

   return submod_key;
}

int addGateSize(int gatesizes_key, YYLTYPE namepos, YYLTYPE vectorpos)
{
   // cut off "[" and "]"
   vectorpos.first_column++;
   vectorpos.last_column--;

   int gatesize_key = np->create("gatesize", gatesizes_key);
   np->set(gatesize_key, "name", namepos);
   np->set(gatesize_key, "size", vectorpos);
   return gatesize_key;
}

int addSubstparam(int substparams_key, YYLTYPE namepos, YYLTYPE valuepos)
{
   int substparam_key = np->create("substparam", substparams_key);
   np->set(substparam_key, "name", namepos);
   np->set(substparam_key, "value", valuepos);
   return substparam_key;
}

int addSubstmachine(int substmachines_key, YYLTYPE namepos)
{
   int substmachine_key = np->create("substmachine", substmachines_key);
   np->set(substmachine_key, "value", namepos);
   return substmachine_key;
}

int addLoopVar(int forloop_key, YYLTYPE varnamepos, YYLTYPE frompos, YYLTYPE topos)
{
   int loopvar_key = np->create("loopvar", forloop_key);
   np->set(loopvar_key, "name", varnamepos);
   np->set(loopvar_key, "fromvalue", frompos);
   np->set(loopvar_key, "tovalue", topos);
   return loopvar_key;
}

int addConnAttr(int conn_key, char *attrname, YYLTYPE valuepos)
{
    int connattr_key = np->create("connattr", conn_key);
    np->set(connattr_key,"name", attrname);
    np->set(connattr_key,"value", valuepos);
    return connattr_key;
}


int addNetwork(int nedfile_key, YYLTYPE namepos, YYLTYPE typepos, YYLTYPE likepos)
{
   int network_key = np->create("network", nedfile_key);
   np->set(network_key, "name", namepos);
   np->set(network_key, "type-name", typepos);
   np->set(network_key, "like-name", likepos);

   return network_key;
}

int findSubmoduleKey(YYLTYPE modulenamepos)
{
   int key = np->findChild(SUBMODS_KEY,"name",np->nedsource->get(modulenamepos));

   if (key==-1)
      yyerror("invalid submodule name");
   else if (key==-2)
      yyerror("nonunique submodule name");
   return key;
}

YYLTYPE trimBrackets(YYLTYPE vectorpos)
{
   // should check it's really brackets that get chopped off
   vectorpos.first_column++;
   vectorpos.last_column--;
   return vectorpos;
}

YYLTYPE trimQuotes(YYLTYPE vectorpos)
{
   // should check it's really quotes that get chopped off
   vectorpos.first_column++;
   vectorpos.last_column--;
   return vectorpos;
}

void swapConnection(int conn_key)
{
   np->swap(conn_key, "src-ownerkey", "dest-ownerkey");
   np->swap(conn_key, "srcgate", "destgate");
   np->swap(conn_key, "src-mod-index", "dest-mod-index");
   np->swap(conn_key, "src-gate-index", "dest-gate-index");
}

void setDisplayString(int key, YYLTYPE dispstrpos)
{
  // cut off quotes
  dispstrpos.first_column++;
  dispstrpos.last_column--;

  np->set(key,"displaystring", np->nedsource->get(dispstrpos) );
}


#endif



